
     REM This routine is merged into DOS_Defn.BAS; RUN 6000 to start.
     REM If the DOS_Demo m/code block is not found then DOS_Defn will attempt
     REM to load it from the default LOAD medium as "DOS_DEMO" CODE 31989,410.
     REM DSK2TAP joins together a TAP file which has been split into a series
     REM of blocks (max. 16kb each) and saves the re-assembled file to disk.
     REM I use it to copy a TAP file into a DSK file for testing TAP2DSK.
     REM I use Mael Horz's excellent HxD hex editor to split the TAP files.
     REM Follow the prompts; enter a blocksize > 16k to finish.

6001 GO SUB 900 : LET pointer=k0: LET base=k32k-k32: POKE 23658,k8:
     LET bhi=FN i(base): LET blo=FN o(base): LET page=k5-(k3 AND base>=k32k):
     LET fd=k16k: LET fs=k1: DEF FN i(v)=INT (v/kFG): DEF FN o(v)=FN l(v,kFG)
6005 INPUT "Enter TAP file name ";LINE t$: IF t$(LEN t$-k3 TO)<>".TAP" THEN LET t$=t$+".TAP"
     REM open TAP file
6010 PRINT "Opening ";t$''"Load blocks at ";base: GO SUB FN a("O",t$,k3,k2,k2,k4):
     IF Aerr THEN PRINT "ERROR ";Aerr-k1: STOP
6020 INPUT "Block #";(fs);" size (default=";(fd);")"'LINE s$:
     LET s$=s$+(STR$ fd AND s$=""): LET fd=ABS INT VAL s$:
     IF NOT fd OR fd>k16k THEN GO SUB FN a("C",t$,k3,k0,k0,k0): STOP
6030 LET l$="="+STR$ fd: GO SUB FN a("W",l$,k3,page,bhi,blo): GO SUB FN a("F","A",k0,k0,k0,k0):
     LET pointer=pointer+fd: PRINT AT k5,k0;"Size: ";pointer,"Free: ";HL;"kb",: LET fs=fs+k1: GO TO 6020